/*
 * copyHistory, cloneHistory, copyForms, and cloneForms functions
 * have been taken from Pike's Clone Window 0.2.6 extension.
 * Pike's extension: http://www.pikey.me.uk/mozilla/#cw
 *
 */

/***************** DEBUGGING FUNCTIONS ********************/

function print(string)
{
	consoleService.logStringMessage(string);
}

function dumpVisibleTabData()
{
	print("==== dumpVisibleTabList() ====");
	for(var i=0; i<visibleTabData.length; i++) {
		print(i + " " + visibleTabData[i][0] + " (" + visibleTabData[i][1] + ") window=" + visibleTabData[i][2] +  " tab=" + visibleTabData[i][3]);
	}
	print("==== end dumpVisibleTabList ====");
}

function dumpTabListData()
{
	print("==== dumpTabListData() ====");
	for(var i=0; i<tabListData.length; i++) {
		print(i + " " + tabListData[i][0] + " (" + tabListData[i][1] + ") window=" + tabListData[i][2] +  " tab=" + tabListData[i][3]);
	}
	print("==== end dumpTabListData ===");

}

function dumpFlags(value)
{
	var flag=1;

	while (value > 0) {
		if (value & 1)
			print(flag);

		flag = flag * 2;
		value = value >> 1;
	}
}

/**************** END DEBUGGING FUNCTIONS ******************/


function findNextWin(windowNumber)
{
	for (var i = 0; i < visibleTabData.length; i++) {
		if (visibleTabData[i][2] > windowNumber) {
			return visibleTabData[i][6];
		}
	}
	return null;
}

function findPrevWin(windowNumber)
{
	for (var i = visibleTabData.length-1; i >= 0; i--) {
		if (visibleTabData[i][2] < windowNumber) {
			return visibleTabData[i][6];
		}
	}
	return null;
}

function findLastTabInWindow(arrayIndex)
{
	var lastTab = -1;

	for (var i = arrayIndex; i < visibleTabData.length; i++) {
		if (visibleTabData[i][3] == -1) {
			lastTab = i-1;  break;
		}
	}
	if (lastTab == -1) lastTab = i-1;

	return lastTab;
}

/*function getWin(windowNumber)
{
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var enumerator = wm.getEnumerator("navigator:browser");
	var win, count = 0;

	while(enumerator.hasMoreElements())
	{
		win = enumerator.getNext();

		if (count == windowNumber)
			return win;
		else
			count++;
	}
	return null;
}*/

function copyHistory(originalHistory)
{
	// Copy passed in history into an array and return it
	var copiedHistory = new Array();
	for (var i = 0; i < originalHistory.count; i++)
	{
		copiedHistory.push(originalHistory.getEntryAtIndex(i, false));
	}
	copiedHistory.index = originalHistory.index;
	return copiedHistory;
}

function cloneHistory(webNav, copiedHistory)
{
	// Clone history from var
	var newHistory = webNav.sessionHistory;
	newHistory.QueryInterface(Components.interfaces.nsISHistoryInternal);
	if (newHistory.count > 0)
	{
		newHistory.PurgeHistory(newHistory.count);
	}
	for (var i = 0; i < copiedHistory.length; i++)
	{
		newHistory.addEntry(copiedHistory[i], true);
	}
	
	// Goto current history location
	if (copiedHistory.length > 0 && copiedHistory.index >= 0)
	{
		webNav.gotoIndex(copiedHistory.index);
	}
}

function copyForms(originalForms)
{
	var copiedForms = new Array();
	for (var i = 0; i < originalForms.length; i++)
	{
		copiedForms[i] = new Array();
		for (var j = 0; j < originalForms[i].elements.length; j++)
		{
			var elem = originalForms[i].elements[j];
			if (elem.type == 'submit' || elem.type == 'reset' || elem.type == 'image' || elem.type == 'button')
			{
				// Push empty value so we match up with form order when restoring
				copiedForms[i].push(null);
			}
			else if (elem.type == 'checkbox' || elem.type == 'radio')
			{
				copiedForms[i].push(elem.checked);
			}
			else
			{
				copiedForms[i].push(elem.value);
			}
		}
	}
	return copiedForms;
}

function cloneForms(newForms, copiedForms)
{
	for (var i = 0; i < newForms.length; i++)
	{
		for (var j = 0; j < newForms[i].length; j++)
		{
			var elem = newForms[i].elements[j];
			if (elem.type == 'submit' || elem.type == 'reset' || elem.type == 'image' || elem.type == 'button')
			{
				continue;
			}
			else if (elem.type == 'checkbox' || elem.type == 'radio')
			{
				elem.checked = copiedForms[i][j];
			}
			else
			{
				elem.value = copiedForms[i][j];
			}
		}
	}
}