const STATE_START = Components.interfaces.nsIWebProgressListener.STATE_START;
const STATE_STOP = Components.interfaces.nsIWebProgressListener.STATE_STOP;

var tabManagerListener =
{
	QueryInterface: function(aIID)
	{
		if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
		aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
		aIID.equals(Components.interfaces.nsISupports))
			return this;

		throw Components.results.NS_NOINTERFACE;
	},
	onStateChange: function(aProgress, aRequest, aFlag, aStatus)
	{
		print("onStateChange(" + aProgress + "," + aRequest + "," + aFlag + "," + aStatus + ")");
		if(aFlag & STATE_STOP) {
				window.setTimeout(displayOpenTabs, 250);
		}
		return 0;
	},
	onLocationChange: function(aProgress, aRequest, aURI)
	{
		//window.setTimeout(displayOpenTabs, 250);
		print("onLocationChange(" + aProgress + "," + aRequest + "," + aURI + ")");
		return 0;
	},
	onProgressChange: function(webProgress, request, curSelfProgress, maxSelfProgress, curTotalProgress, maxTotalProgress) {
		print("onProgressChange(" + webProgress + "," + request + "," + curSelfProgress + "/" + maxSelfProgress + "," + curTotalProgress + "/" + maxTotalProgress + ")");

		if (curTotalProgress == maxTotalProgress)
			document.getElementById('progMeter').value = 0;
		else
			document.getElementById('progMeter').value = (curTotalProgress / maxTotalProgress * 100);

		return 0;
	},
	onStatusChange: function(webProgress, request, status, message) {
		print("onStatusChange(" + webProgress + "," + request + "," + status + "," + message + ")");
		document.getElementById('selectedTab').value = message;
		return 0;
	},
	onSecurityChange: function(a,b,c) {return 0;},
	onLinkIconAvailable: function(a) {return 0;}
}

function registerProgressListener()
{
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var enumerator = wm.getEnumerator("navigator:browser");

	while(enumerator.hasMoreElements())
	{
		var win = enumerator.getNext();
		var container = win.gBrowser.mPanelContainer;

 		container.addEventListener("DOMNodeInserted", updateTabs, false);
		container.addEventListener("DOMNodeRemoved", updateTabs, false);
		win.gBrowser.addProgressListener(tabManagerListener, Components.interfaces.nsIWebProgress.NOTIFY_ALL);
	}
	print("registered progresslistener");
}

function unregisterProgressListener()
{
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var enumerator = wm.getEnumerator("navigator:browser");

	while(enumerator.hasMoreElements())
	{
		var win = enumerator.getNext();
		var container = win.gBrowser.mPanelContainer;

 		container.removeEventListener("DOMNodeInserted", updateTabs, false);
		container.removeEventListener("DOMNodeRemoved", updateTabs, false);
		win.gBrowser.removeProgressListener(tabManagerListener);
	}
	print("unregistered progresslistener");
}



