var consoleService = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService);

var debug = true;
var copyMoveToggle = 0;					// Copy=1, Move=0
var tabListData = new Array();
var visibleTabData = new Array();
var treeView, windowCount = -1;

function updateTabs(event)
{
	var selectedTab = document.getElementById('tabList').currentIndex;
	print("updateTabs(" + event.type + ") called, selectedtab=" + selectedTab);

	if (event.type == "DOMNodeRemoved")
		window.setTimeout(displayOpenTabs, 250);
		//window.setTimeout(displayOpenTabsAndSelect(selectedTab), 1000);
	else
		window.setTimeout(displayOpenTabs, 250);

	return;
}

function initTabManager()
{
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var enumerator = wm.getEnumerator("navigator:browser");
	var label = document.getElementById("copymovelabel");
	var appcontent = document.getElementById("appcontent");

	if (copyMoveToggle == 0) {
		label.value = label.getAttribute("movevalue");
	}
	else if (copyMoveToggle == 1) {
		label.value = label.getAttribute("copyvalue");
	}

	if(appcontent) {
		print("appcontent found!!!!!!!!!!");
		appcontent.addEventListener("load", updateTabs, true);
	}

	while(enumerator.hasMoreElements())
	{
		var win = enumerator.getNext();

		win.addEventListener("load", registerProgressListener, false);
		win.addEventListener("unload", unregisterProgressListener, false);
	}

	registerProgressListener();
	registerObserver();
	/*window.addEventListener("load", registerProgressListener, false);
	window.addEventListener("unload", unregisterProgressListener, false);*/

	displayOpenTabs();
}

function shutdownTabManager()
{
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var enumerator = wm.getEnumerator("navigator:browser");
	var appcontent = document.getElementById("appcontent");

	while(enumerator.hasMoreElements())
	{
		var win = enumerator.getNext();
		var container = win.gBrowser.mPanelContainer;

		container.removeEventListener("DOMNodeInserted", updateTabs, false);
		container.removeEventListener("DOMNodeRemoved", updateTabs, false);
		win.removeEventListener("load", registerProgressListener, false);
		win.removeEventListener("unload", unregisterProgressListener, false);
	}

	/*if(appcontent)
		appcontent.removeEventListener("load", updateTabs, true);*/

	unregisterProgressListener();
	tabManagerObserver.unregister();
	window.close();
}

function displayOpenTabs()
{
	gettabListData();
	populateTreeView();
	setTreeView();
}

function displayOpenTabsAndSelect(selectTab)
{
	gettabListData();
	populateTreeView();
	setTreeView();
	//document.getElementById('tabList').view.selection.select(selectTab);
	window.setTimeout(function() {document.getElementById('tabList').view.selection.select(selectTab);}, 100);
}

function focusMe()
{
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var enumerator = wm.getEnumerator("");

	while(enumerator.hasMoreElements())	{
		var win = enumerator.getNext();
		if (win.location == "chrome://tabmanager/content/tabmanager.xul")
			win.focus();
	}
}

function toggleCopyMove()
{
	copyMoveToggle = 1 - copyMoveToggle;
	var label = document.getElementById('copymovelabel');

	if (copyMoveToggle == 0) {
		label.value = label.getAttribute("movevalue");
	}
	else if (copyMoveToggle == 1) {
		label.value = label.getAttribute("copyvalue");
	}
}

function tabListSelect()
{
	var lastTab = -1;
	var selectedTab = document.getElementById('tabList').currentIndex;

	// Sometimes needed for some unknown reason
	if (selectedTab == -1)
		return;
	
	// If selection is a tab (not a window)
	if (visibleTabData[selectedTab][3] != -1)
	{
		var lastTab = findLastTabInWindow(selectedTab);
		
		// Enable/disable left & right buttons
		if (visibleTabData[selectedTab][3] > 0) {
			document.getElementById('left').disabled = false;
		}
		else {
			document.getElementById('left').disabled = true;
		}
		if (selectedTab != lastTab) {
			document.getElementById('right').disabled = false;
		}
		else {
			document.getElementById('right').disabled = true;
		}

		// Enable/disable previous & next window buttons
		if (visibleTabData[selectedTab][2] == 0) {
			document.getElementById('previouswin').disabled = true;
		}
		else {
			document.getElementById('previouswin').disabled = false;
		}
		if (windowCount <= visibleTabData[selectedTab][2]) {
			document.getElementById('nextwin').disabled = true;
		}
		else {
			document.getElementById('nextwin').disabled = false;
		}

		document.getElementById('closetab').disabled = false;
		document.getElementById('selectedTab').value = "Window: " + (visibleTabData[selectedTab][2] + 1) + "  Tab: " + (visibleTabData[selectedTab][3] + 1);
	}
	// If selection is a window, disable all buttons
	else {
		document.getElementById('left').disabled = true;
		document.getElementById('right').disabled = true;
		document.getElementById('previouswin').disabled = true;
		document.getElementById('nextwin').disabled = true;
		document.getElementById('closetab').disabled = true;
		document.getElementById('selectedTab').value = "Window: " + (visibleTabData[selectedTab][2] + 1);
	}
}

function doubleClickList()
{
	tabListSelect();
	focusTab();
}

function gettabListData()
{
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var enumerator = wm.getEnumerator("navigator:browser");
	var oldWindowCount = windowCount;
	var thisTabData;

	windowCount = -1;
	tabListData.length = 0;
	visibleTabData.length = 0;

	while(enumerator.hasMoreElements())
	{
		var win = enumerator.getNext();
		var numTabs = win.gBrowser.mPanelContainer.childNodes.length;
		var thisTitle = (win.gBrowser.selectedBrowser.contentTitle) ?
			win.gBrowser.selectedBrowser.contentTitle : "Untitled";

		windowCount++;
		thisTabData = new Array(9);
		thisTabData[0] = "Window " + (windowCount + 1) + " [ " + thisTitle + " ]";
		thisTabData[1] = "";
		thisTabData[2] = windowCount;
		thisTabData[3] = -1;
		thisTabData[4] = true;		// Is container
		thisTabData[5] = true;		// Is container open?
		thisTabData[6] = win;
		thisTabData[7] = null;
		thisTabData[8] = false;

		tabListData.push(thisTabData);
		visibleTabData.push(thisTabData);

		for(var tabNum=0; tabNum<numTabs; tabNum++)
		{
			//var browser = win.gBrowser.mTabs[tabNum];
			var browser = win.gBrowser.getBrowserAtIndex(tabNum);
			var URI = (browser.currentURI.spec) ? browser.currentURI.spec : "(Untitled)";
			var pageTitle = (browser.contentTitle) ? browser.contentTitle : "(Untitled)";

			var thisTabData = new Array(9);
			thisTabData[0] = pageTitle;
			thisTabData[1] = URI;
			thisTabData[2] = windowCount;
			thisTabData[3] = tabNum;
			thisTabData[4] = false;				// Is container
			thisTabData[5] = false;				// Is container open?
			thisTabData[6] = win;
			thisTabData[7] = win.gBrowser.mTabs[tabNum];
			if (browser == win.gBrowser.selectedBrowser)
				thisTabData[8] = true;
			else
				thisTabData[8] = false;

			tabListData.push(thisTabData);
			visibleTabData.push(thisTabData);
		}
	}

	// If number of windows changed, re-register progress listener
	if (oldWindowCount != windowCount) {
		print("oldWindowCount=" + oldWindowCount + " newWindowCount=" + windowCount + ", re-registering progress listener");
		registerProgressListener();
	}
}

function populateTreeView()
{
	treeView = {
		get rowCount() { return visibleTabData.length; },
		getCellText : function(row, column) {
			if (column.id == "titleCol")
				return visibleTabData[row][0];
			else if (column.id == "uriCol")
				return visibleTabData[row][1];
			else
				return "error"
		},
		setTree: function(treebox) { this.treebox = treebox; },
		isSeparator: function(row) { return false; },
		isSorted: function() { return false; },
		isEditable: function(idx, column) { return false; },
		getImageSrc: function(row, col) { return null; },
		getProgressMode: function(idx,column) {},
		getCellValue: function(idx, column) {},
		cycleHeader: function(col, elem) {},
		selectionChanged: function() {},
		cycleCell: function(idx, column) {},
		performAction: function(action) {},
		performActionOnCell: function(action, index, column) {},
		getRowProperties: function(row, props) {},
		getCellProperties: function(row, col, props) {
			var aserv = Components.classes['@mozilla.org/atom-service;1'].getService(Components.interfaces.nsIAtomService);

			if (visibleTabData[row][8]) {
				props.AppendElement(aserv.getAtom("currentTab"));
			}
			if (visibleTabData[row][3] == -1) {
				props.AppendElement(aserv.getAtom("windowTitle"));
			}
		},
		getColumnProperties: function(column, prop) {},
		isContainer: function(row) { return visibleTabData[row][4];	},
		isContainerOpen: function(row) { return visibleTabData[row][5]; },
		isContainerEmpty: function(row) { return false; },
		getLevel: function(row) {
			if (this.isContainer(row)) return 0;
			return 1;
		},
		hasNextSibling: function(row, after) {
			var thisLevel = this.getLevel(row);
			for (var t = row+1; t < visibleTabData.length; t++)
			{
				var nextLevel = this.getLevel(t);
				if (nextLevel == thisLevel)	return true;
				else if (nextLevel < thisLevel) return false;
			}
			return false;
		},
		getParentIndex: function(row) {
			if (this.isContainer(row)) return -1;
			for (var t = row-1; t >= 0; t--) {
				if (this.isContainer(t)) return t;
			}
			return -1;
		},
		getLastSibling: function(row) {
			if (this.isContainer(row)) return -1;
			for (var t = row; t < visibleTabData.length; t++) {
				if (this.isContainer(t)) return t-1;
			}
			if (t == visibleTabData.length) return t-1;
			return -1;
		},
		toggleOpenState: function(row) {
			var item = visibleTabData[row];
			if (!item[4]) return;

			// Close tree
			if (item[5]) {
				item[5] = false;
				var thisLevel = this.getLevel(row);
				var deletecount = 0;

				for (var t = row + 1; t < visibleTabData.length; t++) {
					if (this.getLevel(t) > thisLevel) deletecount++;
					else break;
				}
				if (deletecount) {
					visibleTabData.splice(row + 1, deletecount);
					this.treebox.rowCountChanged(row + 1, -deletecount);
				}
			}
			// Open tree
			else {
				item[5] = true;

				windowNum = visibleTabData[row][2];
				for (var tabListStart = 0; tabListStart < tabListData.length; tabListStart++) {
					if (tabListData[tabListStart][2] == windowNum) {
						tabListStart++; break;
					}
				}
				if (tabListStart == tabListData.length) {
					alert("error");	return;
				}

				for (var tabListEnd = tabListStart; tabListEnd < tabListData.length; tabListEnd++) {
					if (tabListData[tabListEnd][2] > windowNum) {
						tabListEnd--; break;
					}
					if (tabListEnd == tabListData.length-1) break;
				}

				for (var i = tabListStart; i <= tabListEnd; i++) {
					var thisTabData = new Array(9);
					for (var j = 0; j < 9; j++) {
						thisTabData[j] = tabListData[i][j];
					}
					visibleTabData.splice(row + i + 1 - tabListStart, 0, thisTabData);
				}
				this.treebox.rowCountChanged(row + 1, tabListEnd-tabListStart+1);
			}
		}
	};
}

function setTreeView()
{
	document.getElementById('tabList').view=treeView;
}