
function focusTab()
{
	var selectedTab = document.getElementById('tabList').currentIndex;
	if (selectedTab == -1) return;

	var win = visibleTabData[selectedTab][6];
	var newTabFocus = visibleTabData[selectedTab][7];

	win.gBrowser.selectedTab = newTabFocus;
	window.setTimeout(function() {focusMe();}, 100);
	displayOpenTabsAndSelect(selectedTab);
}

function moveTabLeft()
{
	var selectedTab = document.getElementById('tabList').currentIndex;
	if (selectedTab == -1) return;

	var win = visibleTabData[selectedTab][6];
	var tab = visibleTabData[selectedTab][7];
	
	win.gBrowser.moveTabTo(tab, visibleTabData[selectedTab][3]-1);
	displayOpenTabsAndSelect(selectedTab-1);
}

function moveTabRight()
{
	var selectedTab = document.getElementById('tabList').currentIndex;
	if (selectedTab == -1) return;

	var win = visibleTabData[selectedTab][6];
	var tab = visibleTabData[selectedTab][7];
	
	win.gBrowser.moveTabTo(tab, visibleTabData[selectedTab][3]+1);
	displayOpenTabsAndSelect(selectedTab+1);
}

function moveTabNextWin()
{
	var selectedTab = document.getElementById('tabList').currentIndex;
	if (selectedTab == -1) return;
	
	var thisWinNum = visibleTabData[selectedTab][2];
	var thisTabNum = visibleTabData[selectedTab][3];
	var thisWin = visibleTabData[selectedTab][6];
	var thisBrowser = thisWin.gBrowser.getBrowserAtIndex(thisTabNum);
	var nextWin = findNextWin(thisWinNum);

	moveTabToWin(thisBrowser, nextWin);
	if (copyMoveToggle == 0) closeTab(selectedTab);

	//window.setTimeout(function() {focusMe();}, 200);
	//window.setTimeout(function() {displayOpenTabsAndSelect(selectedTab);}, 500);
	//window.setTimeout(function() {displayOpenTabs();}, 500);
}

function moveTabPrevWin()
{
	var selectedTab = document.getElementById('tabList').currentIndex;
	if (selectedTab == -1) return;
	
	var thisWinNum = visibleTabData[selectedTab][2];
	var thisTabNum = visibleTabData[selectedTab][3];
	var thisWin = visibleTabData[selectedTab][6];
	var thisBrowser = thisWin.gBrowser.getBrowserAtIndex(thisTabNum);
	var prevWin = findPrevWin(thisWinNum);

	moveTabToWin(thisBrowser, prevWin);
	if (copyMoveToggle == 0) closeTab(selectedTab);

	//window.setTimeout(function() {focusMe();}, 200);
	//window.setTimeout(function() {displayOpenTabsAndSelect(selectedTab+1);}, 500);
	//window.setTimeout(function() {displayOpenTabs();}, 500);
}

function moveTabToWin(browser, win)
{
	var clonedHistory = copyHistory(browser.sessionHistory);
	if (browser.contentWindow && browser.contentWindow.document.forms) {
		var clonedForms = copyForms(browser.contentWindow.document.forms);
	}
	else {
		var clonedForms = null;
	}

	var scrollPosX = browser.contentWindow.scrollX;
	var scrollPosY = browser.contentWindow.scrollY;
	//var zoomFactor = ZoomManager.prototype.getInstance().textZoom;

	var newTab = win.gBrowser.addTab();
	win.gBrowser.selectedTab = newTab;

	var openedBrowser = win.gBrowser.getBrowserForTab(newTab);
	cloneHistory(openedBrowser.webNavigation, clonedHistory);

	if (clonedForms) {
		window.setTimeout(function() {cloneForms(openedBrowser.contentWindow.document.forms, clonedForms);}, 100);
	}
	window.setTimeout(function() {openedBrowser.contentWindow.scrollTo(scrollPosX, scrollPosY);}, 100);
	window.setTimeout(function() {focusMe();}, 500);
}

/* UNUSED 
function newTab()
{
	var selectedTab = document.getElementById('tabList').currentIndex;
	if (selectedTab == -1) return;
	
	var thisWin = visibleTabData[selectedTab][6];
	var newTab = thisWin.gBrowser.addTab();
	thisWin.gBrowser.selectedTab = newTab;

	window.setTimeout(function() {focusMe();}, 100);
	window.setTimeout(function() {displayOpenTabsAndSelect(selectedTab);}, 500);
}
/* UNUSED */

function newWindow()
{
	var selectedTab = document.getElementById('tabList').currentIndex;

	window.open();
	window.setTimeout(function() {focusMe();}, 100);
	//window.setTimeout(function() {displayOpenTabsAndSelect(selectedTab);}, 500);
}

function closeTab(tabNumber)
{
	if (!tabNumber)
		var selectedTab = document.getElementById('tabList').currentIndex;
	else
		var selectedTab = tabNumber;

	if (selectedTab == -1) return;

	var thisWin = visibleTabData[selectedTab][6];
	var thisTab = thisWin.gBrowser.mTabs[visibleTabData[selectedTab][3]];

	// Complex but avoids index out of bounds errors with short circuit logic
	if (selectedTab == visibleTabData.length-1 && visibleTabData[selectedTab][3] == 0) {
		thisWin.close();
	}
	else if(selectedTab == visibleTabData.length-1 && visibleTabData[selectedTab][3] > 0) {
		thisWin.gBrowser.removeTab(thisTab);
	}
	else if (visibleTabData[selectedTab][3] == 0 && visibleTabData[selectedTab+1][2] > visibleTabData[selectedTab][2]) {
		thisWin.close();
	}
	else {
		thisWin.gBrowser.removeTab(thisTab);
	}

	if (selectedTab >= visibleTabData.length)
		selectedTab = visibleTabData.length - 1;

	//displayOpenTabsAndSelect(selectedTab);
	//document.getElementById('tabList').view.selection.select(selectedTab);
	window.setTimeout(function() {focusMe();}, 100);
}